import sys, os, time, subprocess, re
import Tkinter as tk


class Screen:

	def __init__(self, master):
		frame = tk.Frame(master)
		frame.pack()
		self.Line = 0
		self.Replace = False

		self.Read  = tk.Button( frame,text="Read" , command=self.readData , anchor=tk.W).pack(side=tk.LEFT )
		self.Check = tk.Checkbutton( master, text="Replace Spaces with FF", variable=self.Replace, command=self.cb)
		self.Write = tk.Button( frame,text="Write", command=self.writeData, anchor=tk.E).pack(side=tk.RIGHT)
		self.Clear = tk.Button( frame,text="Clear", command=self.clearData, anchor=tk.E).pack(side=tk.RIGHT)
		self.info = tk.Label( frame, text="  Address = 0x50  " ).pack()
		self.EntryC = tk.Text( master, width=100, height=10 )
		self.EntryC.grid(row=1, column=0)
		self.EntryH = tk.Text( master, width=100, height=15 )
		self.EntryH.grid(row=1, column=1)

		self.Check.pack()
		self.EntryC.pack( ipady=0 )
		self.EntryH.pack( ipady=0 )
		self.readData()

	def cb(self):
		Replace = self.Replace
		if Replace == True:
			self.Replace = False
			print( "The variable is..." + str(self.Replace) )
			return
		elif Replace == False:
			self.Replace = True
			print( "The variable is..." + str(self.Replace) )
			return

	def clearData(self):
		LineCount = int(self.EntryC.index('end-1c').split('.')[0])
		LineCount = float(str(LineCount))
		os.system("i2cset -y 1 0x50 0x00 0x00")

		for A in range( 0,256 ):
			Reg = hex(A)
			os.system("i2cset -y 1 0x50 0x00 %s 0xff i" % (Reg))
		self.readData()

	def readData(self):
		self.List = [[],[],[],[],[],[],[],[],[],[],[],[],[],[],[],[]]
		self.Hex  = [[],[],[],[],[],[],[],[],[],[],[],[],[],[],[],[]]
		self.Characters  = [[],[],[],[],[],[],[],[],[],[],[],[],[],[],[],[]]
		os.system("i2cset -y 1 0x50 0x00 0x00")

		for A in range(0, 256):
			Reg = hex(A)
			cmd = ['i2cget','-y','1','0x50','0x00']
			Out = subprocess.Popen( cmd, stdout=subprocess.PIPE ).communicate()[0]
			Out = int(Out[2:4], 16)
			#if Out == 0:
			#	continue
			if Out == 0xFF:
				Out = 0x00
			self.List[A/16].append(chr(Out))
			Hexadecimal = hex(Out)[2:].zfill(2)
			self.Hex[A/16].append( Hexadecimal )

		print(self.Hex)
		self.EntryH.delete(0.0, tk.END)
		self.EntryH.insert(0.0, "     | 00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F |")

		for X in range(0, 16):
			HexD = ''.join(str(self.Hex[X]))
			TextIn = re.findall(r'[0-9a-fA-F][0-9a-fA-F]', HexD)
			HexD = HexD.replace('[','')			# HexD is the Hexadecimal values in the bottom screen
			HexD = HexD.replace(']','')
			HexD = HexD.replace(',','')
			HexD = HexD.replace("'",'')
			HexD = HexD.replace('    ','|')
			if self.Replace == True:
				HexD = HexD.replace('20','ff')
			HexD = HexD.replace('00','ff')
			TextIn[X] = TextIn[X].replace('ff','00')
			Line = hex(X)
			#print TextIn
			for A in range(len(TextIn)):
				Char = TextIn[A]
				Char = chr(int("0x"+Char, 16))
				if Char == "\n":
					Char = " "
				if ord(Char) == 0:
					Char = " "
				self.Characters[X].append(Char)
			self.Characters[X] = ''.join(self.Characters[X])
			self.Characters[X] = self.Characters[X].replace(',','')
			self.Characters[X].upper()
			self.EntryH.insert( tk.INSERT, "\n  0" + str(Line)[2:].upper() + " | " + HexD + " | " + self.Characters[X])
		for A1 in range(0, len(self.List)):
			for B1 in range(0, len(self.List[A1])):
				if self.List[A1][B1] == "" or ord(self.List[A1][B1]) == 0:
					self.List[A1][B1] = " "
		for A in range(0, 16):
			self.List[A] = ''.join(self.List[A])

		self.List = ''.join(self.List)
		self.EntryC.delete(1.0, tk.END)
		self.EntryC.insert(1.0, self.List)

	def writeData(self):
		LineCount = int(self.EntryC.index('end-1c').split('.')[0])
		LineCount = float(str(LineCount))
		Data = self.EntryC.get(0.0, tk.END)
		os.system("i2cset -y 1 0x50 0x00 0x00")

		for A in range( 0,256 ):
			try:
				Hex = ord(Data[A])
			except:
				Hex = 0xFF
			if Hex == 0x0a:
				Hex = 0xFF
			elif self.Replace == True and Hex == 0x20:
				Hex = 0xFF
			Reg = hex(A)
			os.system("i2cset -y 1 0x50 0x00 %s %s i" % (Reg, Hex))
		self.readData()
		
#1234567890123456123456789012345612345678901234561234567890123456
root = tk.Tk()
root.wm_title("EEPROM editor")
root.geometry("550x400")
Widget = Screen(root)

root.mainloop()
