import time
from time import sleep, strftime
from datetime import datetime
from Adafruit_8x8 import EightByEight

FONT = {
" ":[
 [0,0,0,0,0],
 [0,0,0,0,0],
 [0,0,0,0,0],
 [0,0,0,0,0],
 [0,0,0,0,0],
 [0,0,0,0,0],
 [0,0,0,0,0]
],
"1":[
 [0,0,1,0,0],
 [0,1,1,0,0],
 [0,0,1,0,0],
 [0,0,1,0,0],
 [0,0,1,0,0],
 [0,0,1,0,0],
 [0,1,1,1,0]
],
"2":[
 [0,1,1,1,0],
 [1,0,0,0,1],
 [0,0,0,0,1],
 [0,0,0,1,0],
 [0,0,1,0,0],
 [0,1,0,0,0],
 [1,1,1,1,1]
],
"3":[
 [1,1,1,1,1],
 [0,0,0,1,0],
 [0,0,1,0,0],
 [0,0,0,1,0],
 [0,0,0,0,1],
 [1,0,0,0,1],
 [0,1,1,1,0]
],
"4":[
 [0,0,0,1,0],
 [0,0,1,1,0],
 [0,1,0,1,0],
 [1,0,0,1,0],
 [1,1,1,1,1],
 [0,0,0,1,0],
 [0,0,0,1,0]
],
"5":[
 [1,1,1,1,1],
 [1,0,0,0,0],
 [1,1,1,1,0],
 [0,0,0,0,1],
 [0,0,0,0,1],
 [1,0,0,0,1],
 [0,1,1,1,0]
],
"6":[
 [0,0,1,1,0],
 [0,1,0,0,0],
 [1,0,0,0,0],
 [1,1,1,1,0],
 [1,0,0,0,1],
 [1,0,0,0,1],
 [0,1,1,1,0]
],
"7":[
 [1,1,1,1,1],
 [0,0,0,0,1],
 [0,0,0,1,0],
 [0,0,1,0,0],
 [0,1,0,0,0],
 [0,1,0,0,0],
 [0,1,0,0,0]
],
"8":[
 [0,1,1,1,0],
 [1,0,0,0,1],
 [1,0,0,0,1],
 [0,1,1,1,0],
 [1,0,0,0,1],
 [1,0,0,0,1],
 [0,1,1,1,0]
],
"9":[
 [0,1,1,1,0],
 [1,0,0,0,1],
 [1,0,0,0,1],
 [0,1,1,1,1],
 [0,0,0,0,1],
 [0,0,0,1,0],
 [0,1,1,0,0]
],
"0":[
 [0,1,1,1,0],
 [1,0,0,0,1],
 [1,0,0,1,1],
 [1,0,1,0,1],
 [1,1,0,0,1],
 [1,0,0,0,1],
 [0,1,1,1,0]
]
}


Grid = []
Grids = []

grid1 = EightByEight(address=0x70)
grid2 = EightByEight(address=0x71)
grid1.clear()
grid2.clear()

Render = [
[0,0,0,0,1,1,1,0,0,1,1,1,0,0,0,0],
[0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0],
[0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0],
[0,0,1,0,0,0,0,1,1,0,0,0,0,1,0,0],
[0,1,0,1,0,0,1,0,0,1,0,0,1,0,1,0],
[1,0,0,0,1,0,1,0,0,1,0,1,0,0,0,1],
[1,0,0,1,0,0,0,1,1,0,0,0,1,0,0,1],
[1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1],
[1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1],
[1,0,1,0,0,1,1,0,0,1,1,0,0,1,0,1],
[1,0,1,0,0,1,1,0,0,1,1,0,0,1,0,1],
[0,1,0,1,1,0,0,1,1,0,0,1,1,0,1,0],
[0,0,1,0,0,1,1,0,0,1,1,0,0,1,0,0],
[0,0,0,1,1,0,0,1,1,0,0,1,1,0,0,0],
[0,0,0,0,1,0,0,1,1,0,0,1,0,0,0,0],
[0,0,0,0,0,1,1,0,1,1,1,0,0,0,0,0]
]

Image = True
Repeat = True

def Flash(Repeat, Image):
 grid2.setPixel(5, 5, 1)
 grid2.setPixel(10, 5, 1)
 time.sleep(5)
 grid2.setPixel(5, 5, 0)
 grid2.setPixel(10, 5, 0)
 time.sleep(5)
 Screen(Repeat, Image)

def Clear(Image):
 Render[:] = [[],[],[],[],[],[],[],[],[],[],[],[],[],[],[],[]]
 Screen(Repeat, Image)

def Screen(Repeat, Image):
 if Image == True:
  for X in range(0, 8):
   for Y in range(0, 8):
    Grid1 = Render[X][Y]
    Grid12 = Render[X+8][Y]
    Grid2 = Render[X][Y+8]
    Grid22 = Render[X+8][Y+8]
    grid1.setPixel(X, Y, Grid1)
    grid2.setPixel(X, Y, Grid2)
    grid1.setPixel(X+8, Y, Grid12)
    grid2.setPixel(X+8, Y, Grid22)
  time.sleep(2)
  for X in range(0, 8):
   for Y in range(0, 8):
    grid1.setPixel(X, Y, 0)
    grid2.setPixel(X, Y, 0)
    grid1.setPixel(X+8, Y, 0)
    grid2.setPixel(X+8, Y, 0)
  Render[:] = [[],[],[],[],[],[],[],[],[],[],[],[],[],[],[],[]]
  Screen(True, False)
 else:
  Month = datetime.now().strftime('%m')
  Day = datetime.now().strftime('%d')
  Hour = datetime.now().strftime('%H')
  Minutes = datetime.now().strftime('%M')
  Time = Hour+""+Minutes
  Date = Day+""+Month
  if len( Render[0] ) > 150:
   Clear()
  for A in range(0, 4): # Loop through the Hours & Minutes
   for x in range(0, 7): # Loop down the Render Grid
    for y in range(len(Time[A])): # Loop through the Render grid Left - Right
     Grid = FONT[Time[A]] # Grid Binary layout of the characters
     Grids = FONT[str(Date[A])]
     Bin = Grid[x]
     Bin2 = Grids[x]
     for B in range(len(Bin)):
      Render[x].append(Bin[B])
      Render[x+8].append(Bin2[B])



  if Repeat == False:
   for X in range(0, 7):
    for Y in range(0, 8):
     Grid1 = Render[X][Y]
     Grid12 = Render[X][Y+9]
     if Y == 0:
      Grid12 = 0

     grid1.setPixel(X, Y, Grid1)
     grid1.setPixel(X+8, Y, Grid12)


   for X in range(0, 7):
    for Y in range(0, 7):
     Grid2 = Render[X][Y+8]
     Grid22 = Render[X][Y+13]
     if Y > 1:
      Grid2 = 0
     if Y == 0 or  Y == 1 or  Y == 2 or Y == 3:
      Grid22 = 0
     grid2.setPixel(X, Y, Grid2)
     grid2.setPixel(X+8, Y-4, Grid22)
   for Fl in range(0, 4):
    grid2.setPixel(5, 5, 1)
    grid2.setPixel(10, 5, 1)
    time.sleep(1)
    grid2.setPixel(5, 5, 0)
    grid2.setPixel(10, 5, 0)
    time.sleep(1)
   Repeat = True
  else:
   for X in range(0, 7):
    for Y in range(0, 8):
     Grid1 = Render[X+8][Y]
     Grid12 = Render[X+8][Y+9]
     if Y == 0:
      Grid12 = 0

     grid1.setPixel(X, Y, Grid1)
     grid1.setPixel(X+8, Y, Grid12)


   for X in range(0, 7):
    for Y in range(0, 7):
     Grid2 = Render[X+8][Y+8]
     Grid22 = Render[X+8][Y+13]
     if Y > 1:
      Grid2 = 0
     if Y == 0 or  Y == 1 or  Y == 2 or Y == 3:
      Grid22 = 0
     grid2.setPixel(X, Y, Grid2)
     grid2.setPixel(X+8, Y-4, Grid22)
   Repeat = False
  Flash(Repeat, Image)

Screen(Repeat, Image)
