import time, sys, os
from time import sleep, strftime
from datetime import datetime
from Adafruit_8x8 import EightByEight

FONT = {
" ":[
 [0,0,0,0,0],
 [0,0,0,0,0],
 [0,0,0,0,0],
 [0,0,0,0,0],
 [0,0,0,0,0],
 [0,0,0,0,0],
 [0,0,0,0,0]
],
"1":[
 [0,0,1,0,0],
 [0,1,1,0,0],
 [0,0,1,0,0],
 [0,0,1,0,0],
 [0,0,1,0,0],
 [0,0,1,0,0],
 [0,1,1,1,0]
],
"2":[
 [0,1,1,1,0],
 [1,0,0,0,1],
 [0,0,0,0,1],
 [0,0,0,1,0],
 [0,0,1,0,0],
 [0,1,0,0,0],
 [1,1,1,1,1]
],
"3":[
 [1,1,1,1,1],
 [0,0,0,1,0],
 [0,0,1,0,0],
 [0,0,0,1,0],
 [0,0,0,0,1],
 [1,0,0,0,1],
 [0,1,1,1,0]
],
"4":[
 [0,0,0,1,0],
 [0,0,1,1,0],
 [0,1,0,1,0],
 [1,0,0,1,0],
 [1,1,1,1,1],
 [0,0,0,1,0],
 [0,0,0,1,0]
],
"5":[
 [1,1,1,1,1],
 [1,0,0,0,0],
 [1,1,1,1,0],
 [0,0,0,0,1],
 [0,0,0,0,1],
 [1,0,0,0,1],
 [0,1,1,1,0]
],
"6":[
 [0,0,1,1,0],
 [0,1,0,0,0],
 [1,0,0,0,0],
 [1,1,1,1,0],
 [1,0,0,0,1],
 [1,0,0,0,1],
 [0,1,1,1,0]
],
"7":[
 [1,1,1,1,1],
 [0,0,0,0,1],
 [0,0,0,1,0],
 [0,0,1,0,0],
 [0,1,0,0,0],
 [0,1,0,0,0],
 [0,1,0,0,0]
],
"8":[
 [0,1,1,1,0],
 [1,0,0,0,1],
 [1,0,0,0,1],
 [0,1,1,1,0],
 [1,0,0,0,1],
 [1,0,0,0,1],
 [0,1,1,1,0]
],
"9":[
 [0,1,1,1,0],
 [1,0,0,0,1],
 [1,0,0,0,1],
 [0,1,1,1,1],
 [0,0,0,0,1],
 [0,0,0,1,0],
 [0,1,1,0,0]
],
"0":[
 [0,1,1,1,0],
 [1,0,0,0,1],
 [1,0,0,1,1],
 [1,0,1,0,1],
 [1,1,0,0,1],
 [1,0,0,0,1],
 [0,1,1,1,0]
]
}


Grid = []
Grids = []

grid1 = EightByEight(address=0x70)
grid2 = EightByEight(address=0x71)
grid3 = EightByEight(address=0x72)
grid1.clear()
grid2.clear()
grid3.clear()

Render = [
[],
[],
[],
[],
[],
[],
[],
[],
[],
[],
[],
[],
[],
[],
[],
[]
]
Counter = 0

os.system("hwclock -s")

Once = True

def Flash():
 grid2.setPixel(1, 3, 1)
 grid2.setPixel(4, 3, 1)
 time.sleep(0.2)
 grid2.setPixel(1, 3, 0)
 grid2.setPixel(4, 3, 0)
 Screen()

def Clear():
 time.sleep(1)
 Render[:] = [[],[],[],[],[],[],[],[],[],[],[],[],[],[],[],[]]
 Screen()

def Screen():
 global Once
 global Counter
 Month = datetime.now().strftime('%m')
 Day = datetime.now().strftime('%d')
 Hour = datetime.now().strftime('%H')
 Minutes = datetime.now().strftime('%M')
 Time = Hour+""+Minutes
 Date = Day+""+Month
 Counter = Counter +1 
 if Counter == 300:
  os.system("sudo python "+sys.argv[0]+" False")
 if len( Render[0] ) > 350:
  Clear()
 for A in range(0, 4): # Loop through the Hours & Minutes
  for x in range(0, 7): # Loop down the Render Grid
   for y in range(len(Time[A])): # Loop through the Render grid Left - Right
    Grid = FONT[Time[A]] # Grid Binary layout of the characters
    Grids = FONT[str(Date[A])]
    Bin = Grid[x]
    Bin2 = Grids[x]
    for B in range(len(Bin)):
     Render[x].append(Bin[B])
     Render[x+8].append(Bin2[B])

## Date

 if Once == True:
  for X in range(0, 7):
   for Y in range(0, 8):
    Grid1 = Render[X+8][Y]
    grid1.setPixel(X+8, Y, Grid1)

  for X in range(0, 7):
   for Y in range(0, 7):
    Grid2 = Render[X+8][Y+6]
    if Y >= 4:
     Padding = 1
    else:
     Padding = -2
    grid2.setPixel(X+8, Y+Padding, Grid2)

  for X in range(0, 7):
   for Y in range(0, 8):
    Grid3 = Render[X+8][Y+12]
    if Y == 0:
     Grid3 = 0
    grid3.setPixel(X+8, Y-1, Grid3)
 

  for Z in range(0, 4):
   grid2.setPixel(10+Z,3 , 1)
 

## Date

 for X in range(0, 7):
  for Y in range(0, 8):
   Grid1 = Render[X][Y]
   grid1.setPixel(X, Y, Grid1)

 for X in range(0, 7):
  for Y in range(0, 7):
   Grid2 = 0
   Grid2 = Render[X][Y+6]
   if Y >= 4:
    Padding = 1
   else:
    Padding = -2
   grid2.setPixel(X, Y+Padding, Grid2)

 for X in range(0, 7):
  for Y in range(0, 8):
   Grid3 = Render[X][Y+12]
   if Y == 0:
    Grid3 = 0
   grid3.setPixel(X, Y-1, Grid3)
 Flash()
 Clear()
 print Counter
 Once = False
 Flash()


Screen()
